<script lang="ts">
    import type {
        PlanetCollection,
        PlanetField as PlanetFieldApiType
    } from '$utils/API/Planet.type'
    import Section from '$components/District/DistrictPanel/Section.svelte'
    import { createEventDispatcher, onMount } from 'svelte'
    import { get } from '$lib/fetch'

    export let fields: PlanetCollection
    export let district

    const coordinatesToField = (x: number, y: number): PlanetFieldApiType | null => {
        if (typeof fields[x] === 'undefined' || typeof fields[x][y] === 'undefined') {
            return null
        }

        return fields[x][y][0]
    }

    $: stargates = []
    $: Object.keys(fields).forEach(x => {
        Object.keys(fields[x]).forEach(y => {
            if (fields[x][y][0].type === 'stargate')
                stargates.push(coordinatesToField(parseInt(x), parseInt(y)))
        })
    })

    $: districts = []
    $: Object.keys(fields).forEach(x => {
        Object.keys(fields[x]).forEach(y => {
            if (fields[x][y][0].type === 'district')
                districts.push(coordinatesToField(parseInt(x), parseInt(y)))
        })
    })

    $: factions = districts.reduce(
        (factions, district) => {
            factions[district.faction].number++
            return factions
        },
        {
            empire: { number: 0 },
            conglomerate: { number: 0 },
            federation: { number: 0 }
        }
    )

    let fleets = []
    let summaries = []
    onMount(() => {
        get(`/api/districts/${district?.id}/getFleets`).then(({ res }) => {
            fleets = res
            fleets.forEach(fleet => {
                let departure = new Date(fleet.departure_time)
                let nb_hour = Math.round(fleet.travelTime / 60)
                let nb_minutes = fleet.travelTime - nb_hour * 60
                departure.setHours(departure.getHours() + nb_hour)
                departure.setMinutes(departure.getMinutes() + nb_minutes)
                fleet.arrived = departure
            })
        })

        get(`/api/districts/${district?.id}/battleSummaries`).then(({ res }) => {
            summaries = res.data
            let now = Date.now()
            Object.keys(summaries).forEach(key => {
                summaries[key].date = Math.round(
                    (now.valueOf() - new Date(summaries[key].created_at).valueOf()) / 1000 / 60 / 60
                )
            })
        })
    })
    // $: get(`/api/districts/${district?.id}/getFleets`).then(({ res }) => {
    //     fleets = res
    //     fleets.forEach(fleet => {
    //         let departure = new Date(fleet.departure_time)
    //         let nb_hour = Math.round(fleet.travelTime / 60)
    //         let nb_minutes = fleet.travelTime - nb_hour * 60
    //         departure.setHours(departure.getHours() + nb_hour)
    //         departure.setMinutes(departure.getMinutes() + nb_minutes)
    //         fleet.arrived = departure
    //     })
    // })
    // $: get(`/api/districts/${district?.id}/battleSummaries`).then(({ res }) => {
    //     summaries = res.data
    //     let now = Date.now()
    //     Object.keys(summaries).forEach(key => {
    //         summaries[key].date = Math.round(
    //             (now.valueOf() - new Date(summaries[key].created_at).valueOf()) / 1000 / 60 / 60
    //         )
    //     })
    // })

    const dispatch = createEventDispatcher()
    const selectStargate = stargate => {
        dispatch('select', stargate)
    }
</script>

<main>
    <Section title="Stargates summary" toggle={true}>
        <table class="table-auto w-full">
            <thead>
                <tr>
                    <th>Color</th>
                    <th>Owner</th>
                </tr>
            </thead>
            <tbody>
                {#each stargates as stargate}
                    <tr class="clickable" on:click={() => selectStargate(stargate)}>
                        <td>{stargate.color}</td>
                        <td>{stargate.owner ?? 'free'}</td>
                    </tr>
                {/each}
            </tbody>
        </table>
    </Section>
    <Section title="Districts summary" toggle={false}>
        <table class="table-auto w-full">
            <thead>
                <tr>
                    <th>Faction</th>
                    <th>Number</th>
                </tr>
            </thead>
            <tbody>
                {#each Object.keys(factions) as name}
                    <tr>
                        <td>{name}</td>
                        <td>{factions[name].number}</td>
                    </tr>
                {/each}
            </tbody>
        </table>
    </Section>
    <Section title="Fleet in movement" toggle={false}>
        <table class="table-auto w-full">
            <thead>
                <tr>
                    <th>Direction</th>
                    <th>Arrived hour</th>
                </tr>
            </thead>
            <tbody>
                {#each fleets as fleet}
                    <tr>
                        <td>{fleet.to}</td>
                        <td>{fleet.arrived.getHours()}:{fleet.arrived.getMinutes()}</td>
                    </tr>
                {/each}
            </tbody>
        </table>
    </Section>
    <Section title="Battle summaries" toggle={false}>
        <table class="table-auto w-full">
            <thead>
                <tr>
                    <th>Stargate</th>
                    <th>Date</th>
                    <th>Result</th>
                </tr>
            </thead>
            <tbody>
                {#each Object.keys(summaries)
                    .reverse()
                    .filter(key => summaries[key].date <= 12) as key}
                    <tr>
                        <td
                            >{stargates.find(stargate => stargate.id === summaries[key].stargate.id)
                                ?.color}</td
                        >
                        <td>{summaries[key].date}h ago</td>
                        <td
                            >{summaries[key].win || summaries[key].win === null
                                ? 'Victory'
                                : 'Defeat'}</td
                        >
                    </tr>
                {/each}
            </tbody>
        </table>
    </Section>
</main>

<style lang="postcss">
    main {
        @apply h-[calc(100%-4.75rem)] p-4 pr-10 text-trueGray-900 dark:text-trueGray-50 overflow-auto flex flex-col gap-y-4;

        thead {
            @apply text-left text-trueGray-500 dark:text-trueGray-400;
        }

        tbody > tr {
            @apply hover:bg-trueGray-200 hover:dark:bg-trueGray-800 transition-colors duration-100 ease-out;

            &.clickable {
                @apply cursor-pointer;
            }
        }
    }
</style>
